package net.minecraft.client;

import java.awt.Component;
import java.awt.LayoutManager;
import java.awt.BorderLayout;
import java.awt.Canvas;
import java.applet.Applet;

public class MinecraftApplet extends Applet {
    private Canvas mcCanvas;
    private Minecraft mc;
    private Thread mcThread;
    
    public MinecraftApplet() {
        this.mcThread = null;
    }
    
    public void init() {
        this.mcCanvas = new CanvasMinecraftApplet(this);
        boolean equalsIgnoreCase = false;
        if (this.getParameter("fullscreen") != null) {
            equalsIgnoreCase = this.getParameter("fullscreen").equalsIgnoreCase("true");
        }
        this.mc = new Minecraft(this.mcCanvas, this, this.getWidth(), this.getHeight(), equalsIgnoreCase);
        this.mc.minecraftUri = this.getDocumentBase().getHost();
        if (this.getDocumentBase().getPort() > 0) {
            final StringBuilder sb = new StringBuilder();
            final Minecraft mc = this.mc;
            mc.minecraftUri = sb.append(mc.minecraftUri).append(":").append(this.getDocumentBase().getPort()).toString();
        }
        //Commented code is original and commented out for anti-piracy patch
        //if (this.getParameter("username") != null && this.getParameter("sessionid") != null) {
        if (this.getParameter("username") == null && this.getParameter("sessionid") == null) {
            this.mc.session = new SessionData(this.getParameter("username"), this.getParameter("sessionid"));
            if (this.getParameter("mppass") != null) {
                this.getParameter("mppass");
            }
        }
        if (this.getParameter("loadmap_user") != null && this.getParameter("loadmap_id") != null) {
            this.mc.objectMouseOverString = this.getParameter("loadmap_user");
            this.mc.rightClickDelayTimer = Integer.parseInt(this.getParameter("loadmap_id"));
        }
        else if (this.getParameter("server") != null && this.getParameter("port") != null) {
            this.mc.setServer(this.getParameter("server"), Integer.parseInt(this.getParameter("port")));
        }
        this.mc.hideQuitButton = true;
        this.setLayout((LayoutManager)new BorderLayout());
        this.add((Component)this.mcCanvas, "Center");
        this.mcCanvas.setFocusable(true);
        this.validate();
    }
    
    public final void startMainThread() {
        if (this.mcThread != null) {
            return;
        }
        (this.mcThread = new Thread((Runnable)this.mc, "Minecraft main thread")).start();
    }
    
    public void start() {
        this.mc.isGamePaused = false;
    }
    
    public void stop() {
        this.mc.isGamePaused = true;
    }
    
    public void destroy() {
        this.shutdown();
    }
    
    public final void shutdown() {
        if (this.mcThread == null) {
            return;
        }
        this.mc.running = false;
        try {
            this.mcThread.join(1000L);
        }
        catch (InterruptedException ex2) {
            try {
                this.mc.shutdownMinecraftApplet();
            }
            catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        this.mcThread = null;
    }
}
