package net.minecraft.client;

public final class Timer {
    double ticksPerSecond;
    private double lastHRTime;
    public int elapsedTicks;
    public double renderPartialTicks;
    private double timerSpeed;
    private double elapsedPartialTicks;
    private long lastSyncSysClock;
    private long lastSyncHRClock;
    private double timeSyncAdjustment;
    
    public Timer(final double double1) {
        this.timerSpeed = 1.0f;
        this.elapsedPartialTicks = 0.0f;
        this.timeSyncAdjustment = 1.0;
        this.ticksPerSecond = 20.0f;
        this.lastSyncSysClock = System.currentTimeMillis();
        this.lastSyncHRClock = System.nanoTime() / 1000000L;
    }
    
    public final void updateTimer() {
        final long currentTimeMillis;
        final long n = (currentTimeMillis = System.currentTimeMillis()) - this.lastSyncSysClock;
        final long n2 = System.nanoTime() / 1000000L;
        if (n > 1000L) {
            final double n3 = n / (double)(n2 - this.lastSyncHRClock);
            this.timeSyncAdjustment += (n3 - this.timeSyncAdjustment) * 0.20000000298023224;
            this.lastSyncSysClock = currentTimeMillis;
            this.lastSyncHRClock = n2;
        }
        if (n < 0L) {
            this.lastSyncSysClock = currentTimeMillis;
            this.lastSyncHRClock = n2;
        }
        final double lastHRTime;
        double n3 = ((lastHRTime = n2 / 1000.0) - this.lastHRTime) * this.timeSyncAdjustment;
        this.lastHRTime = lastHRTime;
        if (n3 < 0.0) {
            n3 = 0.0;
        }
        if (n3 > 1.0) {
            n3 = 1.0;
        }
        this.elapsedPartialTicks += (double)(n3 * this.timerSpeed * this.ticksPerSecond);
        this.elapsedTicks = (int)this.elapsedPartialTicks;
        this.elapsedPartialTicks -= this.elapsedTicks;
        if (this.elapsedTicks > 10) {
            this.elapsedTicks = 10;
        }
        this.renderPartialTicks = this.elapsedPartialTicks;
    }
}
