package net.minecraft.client.gui;

import org.lwjgl.opengl.GL11;
import net.minecraft.client.renderer.Tessellator;

public class Gui {
    protected double zLevel;
    
    public Gui() {
        this.zLevel = 0.0f;
    }
    
    protected static void drawRect(final int xCoordLeft, final int yCoordUp, final int xCoordRight, final int yCoordDown, final int color) {
        final double n = (color >>> 24) / 255.0f;
        final double n2 = (color >> 16 & 0xFF) / 255.0f;
        final double n3 = (color >> 8 & 0xFF) / 255.0f;
        final double n4 = (color & 0xFF) / 255.0f;
        final Tessellator instance = Tessellator.instance;
        GL11.glEnable(3042);
        GL11.glDisable(3553);
        GL11.glBlendFunc(770, 771);
        GL11.glColor4d(n2, n3, n4, n);
        instance.startDrawingQuads();
        instance.addVertex((double)xCoordLeft, (double)yCoordDown, 0.0f);
        instance.addVertex((double)xCoordRight, (double)yCoordDown, 0.0f);
        instance.addVertex((double)xCoordRight, (double)yCoordUp, 0.0f);
        instance.addVertex((double)xCoordLeft, (double)yCoordUp, 0.0f);
        instance.draw();
        GL11.glEnable(3553);
        GL11.glDisable(3042);
    }
    
    protected static void drawGradientRect(final int xCoordLeft, final int yCoordUp, final int xCoordRight, final int yCoordDown, final int upperGradient, final int lowerGradient) {
        final double double4 = (upperGradient >>> 24) / 255.0f;
        final double double5 = (upperGradient >> 16 & 0xFF) / 255.0f;
        final double double6 = (upperGradient >> 8 & 0xFF) / 255.0f;
        final double double7 = (upperGradient & 0xFF) / 255.0f;
        final double double8 = (lowerGradient >>> 24) / 255.0f;
        final double double9 = (lowerGradient >> 16 & 0xFF) / 255.0f;
        final double double10 = (lowerGradient >> 8 & 0xFF) / 255.0f;
        final double double11 = (lowerGradient & 0xFF) / 255.0f;
        GL11.glDisable(3553);
        GL11.glEnable(3042);
        GL11.glDisable(3008);
        GL11.glBlendFunc(770, 771);
        final Tessellator instance;
        (instance = Tessellator.instance).startDrawingQuads();
        instance.setColorRGBA_F(double5, double6, double7, double4);
        instance.addVertex((double)xCoordRight, (double)yCoordUp, 0.0f);
        instance.addVertex((double)xCoordLeft, (double)yCoordUp, 0.0f);
        instance.setColorRGBA_F(double9, double10, double11, double8);
        instance.addVertex((double)xCoordLeft, (double)yCoordDown, 0.0f);
        instance.addVertex((double)xCoordRight, (double)yCoordDown, 0.0f);
        instance.draw();
        GL11.glDisable(3042);
        GL11.glEnable(3008);
        GL11.glEnable(3553);
    }
    
    public static void drawCenteredString(final FontRenderer j, final String string, final int integer3, final int integer4, final int integer5) {
        j.drawStringWithShadow(string, integer3 - j.getStringWidth(string) / 2, integer4, integer5);
    }
    
    public static void drawString(final FontRenderer j, final String string, final int integer3, final int integer4, final int integer5) {
        j.drawStringWithShadow(string, integer3, integer4, integer5);
    }
    
    public final void drawTexturedModalRect(final int integer1, final int integer2, final int integer3, final int integer4, final int integer5, final int integer6) {
        final Tessellator instance;
        (instance = Tessellator.instance).startDrawingQuads();
        instance.addVertexWithUV((double)integer1, (double)(integer2 + integer6), this.zLevel, integer3 * 0.00390625f, (integer4 + integer6) * 0.00390625f);
        instance.addVertexWithUV((double)(integer1 + integer5), (double)(integer2 + integer6), this.zLevel, (integer3 + integer5) * 0.00390625f, (integer4 + integer6) * 0.00390625f);
        instance.addVertexWithUV((double)(integer1 + integer5), (double)integer2, this.zLevel, (integer3 + integer5) * 0.00390625f, integer4 * 0.00390625f);
        instance.addVertexWithUV((double)integer1, (double)integer2, this.zLevel, integer3 * 0.00390625f, integer4 * 0.00390625f);
        instance.draw();
    }
}
