package net.minecraft.client.gui;

import net.minecraft.client.GameSettings;

public final class GuiControls extends GuiScreen {
    private GuiScreen parentScreen;
    private String screenTitle;
    private GameSettings options;
    private int buttonId;
    
    public GuiControls(final GuiScreen i, final GameSettings q) {
        this.screenTitle = "Controls";
        this.buttonId = -1;
        this.parentScreen = i;
        this.options = q;
    }
    
    @Override
    public final void initGui() {
        for (int i = 0; i < this.options.keyBindings.length; ++i) {
            this.controlList.add(new GuiSmallButton(i, this.width / 2 - 155 + i % 2 * 160, this.height / 6 + 24 * (i >> 1), this.options.setKeyBindingString(i)));
        }
        this.controlList.add(new GuiButton(200, this.width / 2 - 100, this.height / 6 + 168, "Done"));
    }
    
    @Override
    protected final void actionPerformed(final GuiButton r) {
        for (int i = 0; i < this.options.keyBindings.length; ++i) {
            ((GuiButton)this.controlList.get(i)).displayString = this.options.setKeyBindingString(i);
        }
        if (r.id == 200) {
            this.mc.displayGuiScreen(this.parentScreen);
            return;
        }
        this.buttonId = r.id;
        r.displayString = "> " + this.options.setKeyBindingString(r.id) + " <";
    }
    
    @Override
    protected final void keyTyped(final char character, final int integer) {
        if (this.buttonId >= 0) {
            this.options.setKeyBinding(this.buttonId, integer);
            ((GuiButton)this.controlList.get(this.buttonId)).displayString = this.options.setKeyBindingString(this.buttonId);
            this.buttonId = -1;
            return;
        }
        super.keyTyped(character, integer);
    }
    
    @Override
    public final void drawScreen(final int xSize_lo, final int ySize_lo, final double double3) {
        this.drawDefaultBackground();
        Gui.drawCenteredString(this.fontRenderer, this.screenTitle, this.width / 2, 20, 16777215);
        super.drawScreen(xSize_lo, ySize_lo, double3);
    }
}
