package net.minecraft.client.gui;

import net.minecraft.client.renderer.RenderEngine;
import org.lwjgl.opengl.GL11;
import net.minecraft.game.recipe.CraftingManager;
import net.minecraft.game.item.ItemStack;
import net.minecraft.client.inventory.InventoryCraftResult;
import net.minecraft.game.entity.player.InventoryPlayer;
import net.minecraft.client.inventory.IInventory;
import net.minecraft.client.inventory.InventoryCrafting;

public final class GuiCrafting extends GuiContainer {
    private InventoryCrafting inventoryCrafting;
    private IInventory iInventory;
    
    public GuiCrafting(final InventoryPlayer b) {
        this.inventoryCrafting = new InventoryCrafting(this, 3, 3);
        this.iInventory = new InventoryCraftResult();
        this.inventorySlots.add(new SlotCrafting(this, this.inventoryCrafting, this.iInventory, 0, 124, 35));
        for (int i = 0; i < 3; ++i) {
            for (int j = 0; j < 3; ++j) {
                this.inventorySlots.add(new Slot(this, this.inventoryCrafting, j + i * 3, 30 + j * 18, 17 + i * 18));
            }
        }
        for (int i = 0; i < 3; ++i) {
            for (int j = 0; j < 9; ++j) {
                this.inventorySlots.add(new Slot(this, b, j + (i + 1) * 9, 8 + j * 18, 84 + i * 18));
            }
        }
        for (int i = 0; i < 9; ++i) {
            this.inventorySlots.add(new Slot(this, b, i, 8 + i * 18, 142));
        }
    }
    
    @Override
    public final void onGuiClosed() {
        super.onGuiClosed();
        for (int i = 0; i < 9; ++i) {
            final ItemStack stackInSlot;
            if ((stackInSlot = this.inventoryCrafting.getStackInSlot(i)) != null) {
                this.mc.thePlayer.dropPlayerItem(stackInSlot);
            }
        }
    }
    
    @Override
    public final void guiCraftingItemsCheck() {
        final int[] arr = new int[9];
        for (int i = 0; i < 3; ++i) {
            for (int j = 0; j < 3; ++j) {
                final int integer = i + j * 3;
                final ItemStack stackInSlot;
                if ((stackInSlot = this.inventoryCrafting.getStackInSlot(integer)) == null) {
                    arr[integer] = -1;
                }
                else {
                    arr[integer] = stackInSlot.itemID;
                }
            }
        }
        this.iInventory.setInventorySlotContents(0, CraftingManager.getInstance().findMatchingRecipe(arr));
    }
    
    @Override
    protected final void drawGuiContainerForegroundLayer() {
        this.fontRenderer.drawString("Crafting", 28, 6, 4210752);
        this.fontRenderer.drawString("Inventory", 8, this.ySize - 96 + 2, 4210752);
    }
    
    @Override
    protected final void drawGuiContainerBackgroundLayer() {
        int texture = this.mc.renderEngine.getTexture("/gui/crafting.png");
        GL11.glColor4d(1.0f, 1.0f, 1.0f, 1.0f);
        RenderEngine.bindTexture(texture);
        texture = (this.width - this.xSize) / 2;
        this.drawTexturedModalRect(texture, (this.height - this.ySize) / 2, 0, 0, this.xSize, this.ySize);
    }
}
