package net.minecraft.client.gui;

import net.minecraft.game.level.World;
import java.io.IOException;
import java.io.InputStream;
import net.minecraft.client.PlayerLoader;
import java.io.FileInputStream;
import java.awt.Dialog;
import java.awt.FileDialog;
import java.io.Reader;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.io.File;

public class GuiLoadLevelScreen extends GuiScreen implements Runnable {
    private GuiScreen parent;
    private boolean finished;
    private boolean loaded;
    //Commented code is original and commented out for anti-piracy patch
    //private String[] levels;
    private String[] levels = {"Load From Button","Load From Button","Load From Button","Load From Button","Load From Button"};
    private String status;
    protected String title;
    boolean frozen;
    File selectedFile;
    
    public GuiLoadLevelScreen(final GuiScreen i) {
        this.finished = false;
        this.loaded = false;
        //Commented code is original and commented out for anti-piracy patch
        //this.levels = null;
        this.status = "";
        this.title = "Load level";
        this.frozen = false;
        this.parent = i;
    }
    
    @Override
    public final void updateScreen() {
        if (this.selectedFile != null) {
            if (!this.selectedFile.getName().endsWith(".mclevel")) {
                this.selectedFile = new File(this.selectedFile.getAbsolutePath() + ".mclevel");
            }
            this.openLevel(this.selectedFile);
            this.selectedFile = null;
            this.mc.displayGuiScreen(null);
        }
    }
    
    public void run() {
        try {
            this.status = "Getting level list..";
            //Commented code is original and commented out for anti-piracy patch
            //this.levels = new BufferedReader((Reader)new InputStreamReader(new URL("http://" + this.mc.minecraftUri + "/listmaps.jsp?user=" + this.mc.session.username).openConnection().getInputStream())).readLine().split(";");
            if (this.levels.length >= 5) {
                this.setLevels(this.levels);
                this.loaded = true;
                return;
            }
            this.status = this.levels[0];
            this.finished = true;
        }
        catch (Exception ex) {
            ex.printStackTrace();
            this.status = "Failed to load levels";
            this.finished = true;
        }
    }
    
    protected void setLevels(final String[] arr) {
        for (int i = 0; i < 5; ++i) {
            ((GuiButton)this.controlList.get(i)).enabled = !arr[i].equals("-");
            ((GuiButton)this.controlList.get(i)).displayString = arr[i];
            ((GuiButton)this.controlList.get(i)).visible = true;
        }
        ((GuiButton)this.controlList.get(5)).visible = true;
    }
    
    @Override
    public void initGui() {
        new Thread((Runnable)this).start();
        for (int i = 0; i < 5; ++i) {
            this.controlList.add(new GuiButton(i, this.width / 2 - 100, this.height / 6 + i * 24, "---"));
            ((GuiButton)this.controlList.get(i)).visible = false;
        }
        this.controlList.add(new GuiButton(5, this.width / 2 - 100, this.height / 6 + 120 + 12, "Load file..."));
        this.controlList.add(new GuiButton(6, this.width / 2 - 100, this.height / 6 + 168, "Cancel"));
        ((GuiButton)this.controlList.get(5)).visible = false;
    }
    
    @Override
    protected final void actionPerformed(final GuiButton r) {
        if (this.frozen) {
            return;
        }
        if (!r.enabled) {
            return;
        }
        if (this.loaded && r.id < 5) {
            this.openLevel(r.id);
        }
        if (this.finished || (this.loaded && r.id == 5)) {
            this.frozen = true;
            final GuiLevelDialog guiLevelDialog;
            (guiLevelDialog = new GuiLevelDialog(this)).setDaemon(true);
            guiLevelDialog.start();
        }
        if (this.finished || (this.loaded && r.id == 6)) {
            this.mc.displayGuiScreen(this.parent);
        }
    }
    
    protected FileDialog saveFileDialog() {
        return new FileDialog((Dialog)null, "Load level", 0);
    }
    
    protected void openLevel(final int integer) {
        this.mc.displayGuiScreen(null);
        this.mc.setIngameFocus();
    }
    
    @Override
    public final void drawScreen(final int xSize_lo, final int ySize_lo, final double double3) {
        this.drawDefaultBackground();
        Gui.drawCenteredString(this.fontRenderer, this.title, this.width / 2, 20, 16777215);
        if (!this.loaded) {
            Gui.drawCenteredString(this.fontRenderer, this.status, this.width / 2, this.height / 2 - 4, 16777215);
        }
        super.drawScreen(xSize_lo, ySize_lo, double3);
    }
    
    protected void openLevel(final File file) {
        try {
            final FileInputStream writeLevelTags = new FileInputStream(file);
            final World load = new PlayerLoader(this.mc, this.mc.loadingScreen).load((InputStream)writeLevelTags);
            writeLevelTags.close();
            this.mc.setLevel(load);
        }
        catch (IOException ex) {
            ex.printStackTrace();
        }
    }
}
