package net.minecraft.client.gui;

import net.minecraft.client.GameSettings;

public final class GuiOptions extends GuiScreen {
    private GuiScreen parentScreen;
    private String screenTitle;
    private GameSettings options;
    
    public GuiOptions(final GuiScreen i, final GameSettings q) {
        this.screenTitle = "Options";
        this.parentScreen = i;
        this.options = q;
    }
    
    @Override
    public final void initGui() {
        for (int i = 0; i < this.options.numberOfOptions; ++i) {
            this.controlList.add(new GuiSmallButton(i, this.width / 2 - 155 + i % 2 * 160, this.height / 6 + 24 * (i >> 1), this.options.setOptionString(i)));
        }
        this.controlList.add(new GuiButton(100, this.width / 2 - 100, this.height / 6 + 120 + 12, "Controls..."));
        this.controlList.add(new GuiButton(200, this.width / 2 - 100, this.height / 6 + 168, "Done"));
    }
    
    @Override
    protected final void actionPerformed(final GuiButton r) {
        if (!r.enabled) {
            return;
        }
        if (r.id < 100) {
            this.options.setOptionValue(r.id, 1);
            r.displayString = this.options.setOptionString(r.id);
        }
        if (r.id == 100) {
            this.mc.displayGuiScreen(new GuiControls(this, this.options));
        }
        if (r.id == 200) {
            this.mc.displayGuiScreen(this.parentScreen);
        }
    }
    
    @Override
    public final void drawScreen(final int xSize_lo, final int ySize_lo, final double double3) {
        this.drawDefaultBackground();
        Gui.drawCenteredString(this.fontRenderer, this.screenTitle, this.width / 2, 20, 16777215);
        super.drawScreen(xSize_lo, ySize_lo, double3);
    }
}
