package net.minecraft.client.gui;

import net.minecraft.client.renderer.Tessellator;
import org.lwjgl.opengl.GL11;
import org.lwjgl.input.Keyboard;
import org.lwjgl.input.Mouse;
import java.util.ArrayList;
import java.util.List;
import net.minecraft.client.Minecraft;

public class GuiScreen extends Gui {
    protected Minecraft mc;
    public int width;
    public int height;
    protected List controlList;
    public boolean allowUserInput;
    protected FontRenderer fontRenderer;
    
    public GuiScreen() {
        this.controlList = (List)new ArrayList();
        this.allowUserInput = false;
    }
    
    public void drawScreen(final int xSize_lo, final int ySize_lo, final double double3) {
        for (int i = 0; i < this.controlList.size(); ++i) {
            ((GuiButton)this.controlList.get(i)).drawButton(this.mc, xSize_lo, ySize_lo);
        }
    }
    
    protected void keyTyped(final char character, final int integer) {
        if (integer == 1) {
            this.mc.displayGuiScreen(null);
            this.mc.setIngameFocus();
        }
    }
    
    protected void drawSlotInventory(final int integer1, final int integer2, int integer3) {
        if (integer3 == 0) {
            GuiButton r;
            for (integer3 = 0; integer3 < this.controlList.size(); ++integer3) {
                if ((r = (GuiButton)this.controlList.get(integer3)).mousePressed(integer1, integer2)) {
                    this.mc.sndManager.playSoundFX("random.click", 1.0f, 1.0f);
                    this.actionPerformed(r);
                }
            }
        }
    }
    
    protected void actionPerformed(final GuiButton r) {
    }
    
    public final void setWorldAndResolution(final Minecraft d, final int width, final int height) {
        this.mc = d;
        this.fontRenderer = d.fontRenderer;
        this.width = width;
        this.height = height;
        this.initGui();
    }
    
    public void initGui() {
    }
    
    public void handleMouseInput() {
        if (Mouse.getEventButtonState()) {
            this.drawSlotInventory(Mouse.getEventX() * this.width / this.mc.displayWidth, this.height - Mouse.getEventY() * this.height / this.mc.displayHeight - 1, Mouse.getEventButton());
            return;
        }
    }
    
    public final void handleKeyboardInput() {
        if (Keyboard.getEventKeyState()) {
            if (Keyboard.getEventKey() == 87) {
                this.mc.toggleFullscreen();
                return;
            }
            this.keyTyped(Keyboard.getEventCharacter(), Keyboard.getEventKey());
        }
    }
    
    public void updateScreen() {
    }
    
    public void onGuiClosed() {
    }
    
    public final void drawDefaultBackground() {
        if (this.mc.theWorld != null) {
            Gui.drawGradientRect(0, 0, this.width, this.height, 1610941696, -1607454624);
            return;
        }
        GL11.glDisable(2896);
        GL11.glDisable(2912);
        final Tessellator instance = Tessellator.instance;
        GL11.glBindTexture(3553, this.mc.renderEngine.getTexture("/dirt.png"));
        GL11.glColor4d(1.0f, 1.0f, 1.0f, 1.0f);
        instance.startDrawingQuads();
        instance.setColorOpaque_I(4210752);
        instance.addVertexWithUV(0.0f, (double)this.height, 0.0f, 0.0f, this.height / 32.0f);
        instance.addVertexWithUV((double)this.width, (double)this.height, 0.0f, this.width / 32.0f, this.height / 32.0f);
        instance.addVertexWithUV((double)this.width, 0.0f, 0.0f, this.width / 32.0f, 0.0f);
        instance.addVertexWithUV(0.0f, 0.0f, 0.0f, 0.0f, 0.0f);
        instance.draw();
    }
    
    public boolean doesGuiPauseGame() {
        return true;
    }
}
