package net.minecraft.client.gui;

import net.minecraft.game.item.ItemStack;
import net.minecraft.client.inventory.IInventory;

public class Slot {
    public final int slotIndex;
    public final int xPos;
    public final int yPos;
    public final IInventory inventory;
    private final GuiContainer guiHandler;
    
    public Slot(final GuiContainer j, final IInventory b, final int slotIndex, final int xPos, final int yPos) {
        this.guiHandler = j;
        this.inventory = b;
        this.slotIndex = slotIndex;
        this.xPos = xPos;
        this.yPos = yPos;
    }
    
    public final boolean isAtCursorPos(int integer1, int integer2) {
        final int n = (this.guiHandler.width - this.guiHandler.xSize) / 2;
        final int n2 = (this.guiHandler.height - this.guiHandler.ySize) / 2;
        integer1 -= n;
        integer2 -= n2;
        return integer1 >= this.xPos - 1 && integer1 < this.xPos + 16 + 1 && integer2 >= this.yPos - 1 && integer2 < this.yPos + 16 + 1;
    }
    
    public void onPickupFromSlot() {
    }
    
    public boolean isItemValid(final ItemStack k) {
        return true;
    }
    
    public final void putStack(final ItemStack k) {
        this.inventory.setInventorySlotContents(this.slotIndex, k);
    }
    
    public int getBackgroundIconIndex() {
        return -1;
    }
}
