package net.minecraft.client.inventory;

import net.minecraft.game.item.ItemStack;

public final class InventoryLargeChest implements IInventory {
    private String name;
    private IInventory upperChest;
    private IInventory lowerChest;
    
    public InventoryLargeChest(final String name, final IInventory upperChest, final IInventory lowerChest) {
        this.name = name;
        this.upperChest = upperChest;
        this.lowerChest = lowerChest;
    }
    
    public final int getSizeInventory() {
        return this.upperChest.getSizeInventory() + this.lowerChest.getSizeInventory();
    }
    
    public final String getInvName() {
        return this.name;
    }
    
    public final ItemStack getStackInSlot(final int integer) {
        if (integer >= this.upperChest.getSizeInventory()) {
            return this.lowerChest.getStackInSlot(integer - this.upperChest.getSizeInventory());
        }
        return this.upperChest.getStackInSlot(integer);
    }
    
    public final ItemStack decrStackSize(final int integer1, final int integer2) {
        if (integer1 >= this.upperChest.getSizeInventory()) {
            return this.lowerChest.decrStackSize(integer1 - this.upperChest.getSizeInventory(), integer2);
        }
        return this.upperChest.decrStackSize(integer1, integer2);
    }
    
    public final void setInventorySlotContents(final int integer, final ItemStack itemStack) {
        if (integer >= this.upperChest.getSizeInventory()) {
            this.lowerChest.setInventorySlotContents(integer - this.upperChest.getSizeInventory(), itemStack);
            return;
        }
        this.upperChest.setInventorySlotContents(integer, itemStack);
    }
    
    public final int getInventoryStackLimit() {
        return this.upperChest.getInventoryStackLimit();
    }
}
