package net.minecraft.client.model;

import net.minecraft.game.MathHelper;

public final class ModelCreeper extends ModelBase {
    private ModelRenderer head;
    private ModelRenderer unusedCreeperHeadwear;
    private ModelRenderer body;
    private ModelRenderer leg1;
    private ModelRenderer leg2;
    private ModelRenderer leg3;
    private ModelRenderer leg4;
    
    public ModelCreeper() {
        (this.head = new ModelRenderer(0, 0)).addBox(-4.0f, -8.0f, -4.0f, 8, 8, 8, 0.0f);
        this.head.setRotationPoint(0.0f, 4.0f, 0.0f);
        (this.unusedCreeperHeadwear = new ModelRenderer(32, 0)).addBox(-4.0f, -8.0f, -4.0f, 8, 8, 8, 0.5f);
        this.unusedCreeperHeadwear.setRotationPoint(0.0f, 4.0f, 0.0f);
        (this.body = new ModelRenderer(16, 16)).addBox(-4.0f, 0.0f, -2.0f, 8, 12, 4, 0.0f);
        this.body.setRotationPoint(0.0f, 4.0f, 0.0f);
        (this.leg1 = new ModelRenderer(0, 16)).addBox(-2.0f, 0.0f, -2.0f, 4, 6, 4, 0.0f);
        this.leg1.setRotationPoint(-2.0f, 16.0f, 4.0f);
        (this.leg2 = new ModelRenderer(0, 16)).addBox(-2.0f, 0.0f, -2.0f, 4, 6, 4, 0.0f);
        this.leg2.setRotationPoint(2.0f, 16.0f, 4.0f);
        (this.leg3 = new ModelRenderer(0, 16)).addBox(-2.0f, 0.0f, -2.0f, 4, 6, 4, 0.0f);
        this.leg3.setRotationPoint(-2.0f, 16.0f, -4.0f);
        (this.leg4 = new ModelRenderer(0, 16)).addBox(-2.0f, 0.0f, -2.0f, 4, 6, 4, 0.0f);
        this.leg4.setRotationPoint(2.0f, 16.0f, -4.0f);
    }
    
    @Override
    public final void render(final double limbAngle, final double animationSpeed, final double double3, final double headYaw, final double headPitch, final double double6) {
        this.setRotationAngles(limbAngle, animationSpeed, double3, headYaw, headPitch, 1.0f);
        this.head.render(1.0f);
        this.body.render(1.0f);
        this.leg1.render(1.0f);
        this.leg2.render(1.0f);
        this.leg3.render(1.0f);
        this.leg4.render(1.0f);
    }
    
    @Override
    public final void setRotationAngles(final double limbAngle, final double animationSpeed, final double double3, final double headYaw, final double headPitch, final double double6) {
        this.head.rotateAngleY = headYaw / 57.295776f;
        this.head.rotateAngleX = headPitch / 57.295776f;
        this.leg1.rotateAngleX = MathHelper.cos(limbAngle * 0.6662f) * 1.4f * animationSpeed;
        this.leg2.rotateAngleX = MathHelper.cos(limbAngle * 0.6662f + 3.1415927f) * 1.4f * animationSpeed;
        this.leg3.rotateAngleX = MathHelper.cos(limbAngle * 0.6662f + 3.1415927f) * 1.4f * animationSpeed;
        this.leg4.rotateAngleX = MathHelper.cos(limbAngle * 0.6662f) * 1.4f * animationSpeed;
    }
}
