package net.minecraft.client.particle;

import net.minecraft.client.renderer.Tessellator;
import net.minecraft.game.level.World;

public final class EntityFlameFX extends EntityFX {
    private double flameScale;
    
    public EntityFlameFX(final World world, final double double2, final double double3, final double double4) {
        super(world, double2, double3, double4, 0.0f, 0.0f, 0.0f);
        this.motionX1 *= 0.01f;
        this.motionY1 *= 0.01f;
        this.motionZ1 *= 0.01f;
        this.rand.nextDouble();
        this.rand.nextDouble();
        this.rand.nextDouble();
        this.rand.nextDouble();
        this.rand.nextDouble();
        this.rand.nextDouble();
        this.flameScale = this.particleScale;
        final double particleRed = 1.0f;
        this.particleBlue = particleRed;
        this.particleGreen = particleRed;
        this.particleRed = particleRed;
        this.particleMaxAge = (int)(8.0 / (Math.random() * 0.8 + 0.2)) + 4;
        this.noClip = true;
        this.particleTextureIndex = 48;
    }
    
    @Override
    public final void renderParticle(final Tessellator tessellator, final double double2, final double double3, final double double4, final double double5, final double double6, final double double7) {
        final double n = (this.particleAge + double2) / this.particleMaxAge;
        this.particleScale = this.flameScale * (1.0f - n * n * 0.5f);
        super.renderParticle(tessellator, double2, double3, double4, double5, double6, double7);
    }
    
    @Override
    public final double getEntityBrightness(double double1) {
        double n;
        if ((n = (this.particleAge + double1) / this.particleMaxAge) < 0.0f) {
            n = 0.0f;
        }
        if (n > 1.0f) {
            n = 1.0f;
        }
        return (double1 = super.getEntityBrightness(double1)) * n + (1.0f - n);
    }
    
    @Override
    public final void onEntityUpdate() {
        this.prevPosX = this.posX;
        this.prevPosY = this.posY;
        this.prevPosZ = this.posZ;
        if (this.particleAge++ >= this.particleMaxAge) {
            this.setEntityDead();
        }
        this.moveEntity(this.motionX1, this.motionY1, this.motionZ1);
        this.motionX1 *= 0.96f;
        this.motionY1 *= 0.96f;
        this.motionZ1 *= 0.96f;
        if (this.onGround) {
            this.motionX1 *= 0.7f;
            this.motionZ1 *= 0.7f;
        }
    }
}
