package net.minecraft.client.particle;

import net.minecraft.client.renderer.Tessellator;
import net.minecraft.game.level.World;

public final class EntityLavaFX extends EntityFX {
    private double lavaParticleScale;
    
    public EntityLavaFX(final World world, final double double2, final double double3, final double double4) {
        super(world, double2, double3, double4, 0.0f, 0.0f, 0.0f);
        this.motionX1 *= 0.8f;
        this.motionY1 *= 0.8f;
        this.motionZ1 *= 0.8f;
        this.motionY1 = this.rand.nextDouble() * 0.4f + 0.05f;
        final double particleRed = 1.0f;
        this.particleBlue = particleRed;
        this.particleGreen = particleRed;
        this.particleRed = particleRed;
        this.particleScale *= this.rand.nextDouble() * 2.0f + 0.2f;
        this.lavaParticleScale = this.particleScale;
        this.particleMaxAge = (int)(16.0 / (Math.random() * 0.8 + 0.2));
        this.noClip = false;
        this.particleTextureIndex = 49;
    }
    
    @Override
    public final double getEntityBrightness(final double double1) {
        return 1.0f;
    }
    
    @Override
    public final void renderParticle(final Tessellator tessellator, final double double2, final double double3, final double double4, final double double5, final double double6, final double double7) {
        final double n = (this.particleAge + double2) / this.particleMaxAge;
        this.particleScale = this.lavaParticleScale * (1.0f - n * n);
        super.renderParticle(tessellator, double2, double3, double4, double5, double6, double7);
    }
    
    @Override
    public final void onEntityUpdate() {
        this.prevPosX = this.posX;
        this.prevPosY = this.posY;
        this.prevPosZ = this.posZ;
        if (this.particleAge++ >= this.particleMaxAge) {
            this.setEntityDead();
        }
        if (this.rand.nextDouble() > this.particleAge / (double)this.particleMaxAge) {
            this.worldObj.spawnParticle("smoke", this.posX, this.posY, this.posZ, this.motionX1, this.motionY1, this.motionZ1);
        }
        this.motionY1 -= (double)0.03;
        this.moveEntity(this.motionX1, this.motionY1, this.motionZ1);
        this.motionX1 *= 0.999f;
        this.motionY1 *= 0.999f;
        this.motionZ1 *= 0.999f;
        if (this.onGround) {
            this.motionX1 *= 0.7f;
            this.motionZ1 *= 0.7f;
        }
    }
}
