package net.minecraft.client.particle;

import net.minecraft.client.renderer.entity.RenderManager;
import org.lwjgl.opengl.GL11;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.game.level.World;
import net.minecraft.game.entity.EntityLiving;
import net.minecraft.game.entity.Entity;

public final class EntityPickupFX extends EntityFX {
    private Entity entityToPickUp;
    private EntityLiving entityPickingUp;
    private int age;
    private int maxAge;
    private double yOffs;
    
    public EntityPickupFX(final World world, final Entity b, final EntityLiving e, final double double4) {
        super(world, b.posX, b.posY, b.posZ, b.motionX, b.motionY, b.motionZ);
        this.age = 0;
        this.maxAge = 0;
        this.entityToPickUp = b;
        this.entityPickingUp = e;
        this.maxAge = 3;
        this.yOffs = -0.5f;
    }
    
    @Override
    public final void renderParticle(final Tessellator tessellator, final double double2, double double3, double double4, double double5, double double6, double double7) {
        double double8 = (double8 = (this.age + double2) / this.maxAge) * double8;
        double3 = this.entityToPickUp.posX;
        double4 = this.entityToPickUp.posY;
        double5 = this.entityToPickUp.posZ;
        double6 = this.entityPickingUp.lastTickPosX + (this.entityPickingUp.posX - this.entityPickingUp.lastTickPosX) * double2;
        double7 = this.entityPickingUp.lastTickPosY + (this.entityPickingUp.posY - this.entityPickingUp.lastTickPosY) * double2 + this.yOffs;
        final double n = this.entityPickingUp.lastTickPosZ + (this.entityPickingUp.posZ - this.entityPickingUp.lastTickPosZ) * double2;
        double3 += (double6 - double3) * double8;
        double4 += (double7 - double4) * double8;
        double8 = double5 + (n - double5) * double8;
        GL11.glColor4d(double5 = this.worldObj.getLightBrightness((int)double3, (int)double4, (int)double8), double5, double5, 1.0f);
        RenderManager.instance.renderEntityWithPosYaw(this.entityToPickUp, double3, double4, double8, this.entityToPickUp.rotationYaw, double2);
    }
    
    @Override
    public final void onEntityUpdate() {
        ++this.age;
        if (this.age == this.maxAge) {
            this.setEntityDead();
        }
    }
    
    @Override
    public final int getFXLayer() {
        return 2;
    }
}
