package net.minecraft.client.renderer;

import net.minecraft.client.physics.AxisAlignedBB;

public final class Frustrum implements ICamera {
    private ClippingHelper clippingHelper;
    
    public Frustrum() {
        this.clippingHelper = ClippingHelperImpl.init();
    }
    
    public final boolean isBoundingBoxInFrustrum(final AxisAlignedBB aabb) {
        final ClippingHelper clippingHelper = this.clippingHelper;
        final double minX = aabb.minX;
        final double minY = aabb.minY;
        final double minZ = aabb.minZ;
        final double maxX = aabb.maxX;
        final double maxY = aabb.maxY;
        final double maxZ = aabb.maxZ;
        final double n = maxY;
        final double n2 = maxX;
        final double n3 = minZ;
        final double n4 = minY;
        final double n5 = minX;
        final ClippingHelper clippingHelper2 = clippingHelper;
        for (int i = 0; i < 6; ++i) {
            if (clippingHelper2.frustrum[i][0] * n5 + clippingHelper2.frustrum[i][1] * n4 + clippingHelper2.frustrum[i][2] * n3 + clippingHelper2.frustrum[i][3] <= 0.0f && clippingHelper2.frustrum[i][0] * n2 + clippingHelper2.frustrum[i][1] * n4 + clippingHelper2.frustrum[i][2] * n3 + clippingHelper2.frustrum[i][3] <= 0.0f && clippingHelper2.frustrum[i][0] * n5 + clippingHelper2.frustrum[i][1] * n + clippingHelper2.frustrum[i][2] * n3 + clippingHelper2.frustrum[i][3] <= 0.0f && clippingHelper2.frustrum[i][0] * n2 + clippingHelper2.frustrum[i][1] * n + clippingHelper2.frustrum[i][2] * n3 + clippingHelper2.frustrum[i][3] <= 0.0f && clippingHelper2.frustrum[i][0] * n5 + clippingHelper2.frustrum[i][1] * n4 + clippingHelper2.frustrum[i][2] * maxZ + clippingHelper2.frustrum[i][3] <= 0.0f && clippingHelper2.frustrum[i][0] * n2 + clippingHelper2.frustrum[i][1] * n4 + clippingHelper2.frustrum[i][2] * maxZ + clippingHelper2.frustrum[i][3] <= 0.0f && clippingHelper2.frustrum[i][0] * n5 + clippingHelper2.frustrum[i][1] * n + clippingHelper2.frustrum[i][2] * maxZ + clippingHelper2.frustrum[i][3] <= 0.0f && clippingHelper2.frustrum[i][0] * n2 + clippingHelper2.frustrum[i][1] * n + clippingHelper2.frustrum[i][2] * maxZ + clippingHelper2.frustrum[i][3] <= 0.0f) {
                return false;
            }
        }
        return true;
    }
}
