package net.minecraft.client.renderer;

import net.minecraft.client.player.EntityPlayerSP;
import net.minecraft.game.entity.Entity;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.client.renderer.entity.RenderPlayer;
import net.minecraft.game.block.Block;
import net.minecraft.game.MathHelper;
import org.lwjgl.opengl.GL11;
import net.minecraft.game.item.ItemStack;
import net.minecraft.client.Minecraft;

public final class ItemRenderer {
    private Minecraft mc;
    private ItemStack itemToRender;
    private double equippedProgress;
    private double prevEquippedProgress;
    private int equippedItemSlot;
    private boolean itemSwingState;
    private RenderBlocks renderBlocksInstance;
    
    public ItemRenderer(final Minecraft minecraft) {
        this.itemToRender = null;
        this.equippedProgress = 0.0f;
        this.prevEquippedProgress = 0.0f;
        this.equippedItemSlot = 0;
        this.itemSwingState = false;
        this.renderBlocksInstance = new RenderBlocks();
        this.mc = minecraft;
    }
    
    public final void renderItemInFirstPerson(double double1) {
        double n = this.prevEquippedProgress + (this.equippedProgress - this.prevEquippedProgress) * double1;
        final EntityPlayerSP thePlayer = this.mc.thePlayer;
        GL11.glPushMatrix();
        GL11.glRotated(thePlayer.prevRotationPitch + (thePlayer.rotationPitch - thePlayer.prevRotationPitch) * double1, 1.0f, 0.0f, 0.0f);
        GL11.glRotated(thePlayer.prevRotationYaw + (thePlayer.rotationYaw - thePlayer.prevRotationYaw) * double1, 0.0f, 1.0f, 0.0f);
        RenderHelper.enableStandardItemLighting();
        GL11.glPopMatrix();
        double lightBrightness;
        GL11.glColor4d(lightBrightness = this.mc.theWorld.getLightBrightness((int)thePlayer.posX, (int)thePlayer.posY, (int)thePlayer.posZ), lightBrightness, lightBrightness, 1.0f);
        if (this.itemToRender != null) {
            GL11.glPushMatrix();
            if (this.itemSwingState) {
                final double n2 = MathHelper.sin((lightBrightness = (this.equippedItemSlot + double1) / 8.0f) * 3.1415927f);
                final double n3;
                GL11.glTranslated(-(n3 = MathHelper.sin(MathHelper.sqrt_double(lightBrightness) * 3.1415927f)) * 0.4f, MathHelper.sin(MathHelper.sqrt_double(lightBrightness) * 3.1415927f * 2.0f) * 0.2f, -n2 * 0.2f);
            }
            GL11.glTranslated(0.56f, -0.52f - (1.0f - n) * 0.6f, -0.71999997f);
            GL11.glRotated(45.0f, 0.0f, 1.0f, 0.0f);
            GL11.glEnable(2977);
            if (this.itemSwingState) {
                final double n2 = MathHelper.sin((lightBrightness = (this.equippedItemSlot + double1) / 8.0f) * lightBrightness * 3.1415927f);
                final double n3 = MathHelper.sin(MathHelper.sqrt_double(lightBrightness) * 3.1415927f);
                GL11.glRotated(-n2 * 20.0f, 0.0f, 1.0f, 0.0f);
                GL11.glRotated(-n3 * 20.0f, 0.0f, 0.0f, 1.0f);
                GL11.glRotated(-n3 * 80.0f, 1.0f, 0.0f, 0.0f);
            }
            GL11.glScaled(0.4f, 0.4f, 0.4f);
            if (this.itemToRender.itemID < 256 && Block.blocksList[this.itemToRender.itemID].getRenderType() == 0) {
                GL11.glBindTexture(3553, this.mc.renderEngine.getTexture("/terrain.png"));
                this.renderBlocksInstance.renderBlockOnInventory(Block.blocksList[this.itemToRender.itemID]);
            }
            else {
                if (this.itemToRender.itemID < 256) {
                    GL11.glBindTexture(3553, this.mc.renderEngine.getTexture("/terrain.png"));
                }
                else {
                    GL11.glBindTexture(3553, this.mc.renderEngine.getTexture("/gui/items.png"));
                }
                final Tessellator instance = Tessellator.instance;
                final double n3 = (this.itemToRender.getItem().getIconFromDamage() % 16 << 4) / 256.0f;
                double1 = ((this.itemToRender.getItem().getIconFromDamage() % 16 << 4) + 16) / 256.0f;
                n = (this.itemToRender.getItem().getIconFromDamage() / 16 << 4) / 256.0f;
                lightBrightness = ((this.itemToRender.getItem().getIconFromDamage() / 16 << 4) + 16) / 256.0f;
                GL11.glEnable(2977);
                GL11.glTranslated(0.0f, -0.3f, 0.0f);
                GL11.glScaled(1.5f, 1.5f, 1.5f);
                GL11.glRotated(50.0f, 0.0f, 1.0f, 0.0f);
                GL11.glRotated(335.0f, 0.0f, 0.0f, 1.0f);
                GL11.glTranslated(-0.9375f, -0.0625f, 0.0f);
                Tessellator.setNormal(0.0f, 0.0f, 1.0f);
                instance.startDrawingQuads();
                instance.addVertexWithUV(0.0f, 0.0f, 0.0f, double1, lightBrightness);
                instance.addVertexWithUV(1.0f, 0.0f, 0.0f, n3, lightBrightness);
                instance.addVertexWithUV(1.0f, 1.0f, 0.0f, n3, n);
                instance.addVertexWithUV(0.0f, 1.0f, 0.0f, double1, n);
                instance.draw();
                Tessellator.setNormal(0.0f, 0.0f, -1.0f);
                instance.startDrawingQuads();
                instance.addVertexWithUV(0.0f, 1.0f, -0.0625f, double1, n);
                instance.addVertexWithUV(1.0f, 1.0f, -0.0625f, n3, n);
                instance.addVertexWithUV(1.0f, 0.0f, -0.0625f, n3, lightBrightness);
                instance.addVertexWithUV(0.0f, 0.0f, -0.0625f, double1, lightBrightness);
                instance.draw();
                Tessellator.setNormal(-1.0f, 0.0f, 0.0f);
                instance.startDrawingQuads();
                for (int i = 0; i < 16; ++i) {
                    double n4 = i / 16.0f;
                    final double n5 = double1 + (n3 - double1) * n4 - 0.001953125f;
                    n4 *= 1.0f;
                    instance.addVertexWithUV(n4, 0.0f, -0.0625f, n5, lightBrightness);
                    instance.addVertexWithUV(n4, 0.0f, 0.0f, n5, lightBrightness);
                    instance.addVertexWithUV(n4, 1.0f, 0.0f, n5, n);
                    instance.addVertexWithUV(n4, 1.0f, -0.0625f, n5, n);
                }
                instance.draw();
                Tessellator.setNormal(1.0f, 0.0f, 0.0f);
                instance.startDrawingQuads();
                for (int i = 0; i < 16; ++i) {
                    double n4 = i / 16.0f;
                    final double n5 = double1 + (n3 - double1) * n4 - 0.001953125f;
                    n4 = n4 * 1.0f + 0.0625f;
                    instance.addVertexWithUV(n4, 1.0f, -0.0625f, n5, n);
                    instance.addVertexWithUV(n4, 1.0f, 0.0f, n5, n);
                    instance.addVertexWithUV(n4, 0.0f, 0.0f, n5, lightBrightness);
                    instance.addVertexWithUV(n4, 0.0f, -0.0625f, n5, lightBrightness);
                }
                instance.draw();
                Tessellator.setNormal(0.0f, 1.0f, 0.0f);
                instance.startDrawingQuads();
                for (int i = 0; i < 16; ++i) {
                    double n4 = i / 16.0f;
                    final double n5 = lightBrightness + (n - lightBrightness) * n4 - 0.001953125f;
                    n4 = n4 * 1.0f + 0.0625f;
                    instance.addVertexWithUV(0.0f, n4, 0.0f, double1, n5);
                    instance.addVertexWithUV(1.0f, n4, 0.0f, n3, n5);
                    instance.addVertexWithUV(1.0f, n4, -0.0625f, n3, n5);
                    instance.addVertexWithUV(0.0f, n4, -0.0625f, double1, n5);
                }
                instance.draw();
                Tessellator.setNormal(0.0f, -1.0f, 0.0f);
                instance.startDrawingQuads();
                for (int i = 0; i < 16; ++i) {
                    double n4 = i / 16.0f;
                    final double n5 = lightBrightness + (n - lightBrightness) * n4 - 0.001953125f;
                    n4 *= 1.0f;
                    instance.addVertexWithUV(1.0f, n4, 0.0f, n3, n5);
                    instance.addVertexWithUV(0.0f, n4, 0.0f, double1, n5);
                    instance.addVertexWithUV(0.0f, n4, -0.0625f, double1, n5);
                    instance.addVertexWithUV(1.0f, n4, -0.0625f, n3, n5);
                }
                instance.draw();
                GL11.glDisable(2977);
            }
            GL11.glPopMatrix();
        }
        else {
            GL11.glPushMatrix();
            if (this.itemSwingState) {
                final double n2 = MathHelper.sin((lightBrightness = (this.equippedItemSlot + double1) / 8.0f) * 3.1415927f);
                final double n3;
                GL11.glTranslated(-(n3 = MathHelper.sin(MathHelper.sqrt_double(lightBrightness) * 3.1415927f)) * 0.3f, MathHelper.sin(MathHelper.sqrt_double(lightBrightness) * 3.1415927f * 2.0f) * 0.4f, -n2 * 0.4f);
            }
            GL11.glTranslated(0.64000005f, -0.6f - (1.0f - n) * 0.6f, -0.71999997f);
            GL11.glRotated(45.0f, 0.0f, 1.0f, 0.0f);
            GL11.glEnable(2977);
            if (this.itemSwingState) {
                final double n2 = MathHelper.sin((lightBrightness = (this.equippedItemSlot + double1) / 8.0f) * lightBrightness * 3.1415927f);
                final double n3;
                GL11.glRotated((n3 = MathHelper.sin(MathHelper.sqrt_double(lightBrightness) * 3.1415927f)) * 70.0f, 0.0f, 1.0f, 0.0f);
                GL11.glRotated(-n2 * 20.0f, 0.0f, 0.0f, 1.0f);
            }
            GL11.glBindTexture(3553, this.mc.renderEngine.getTextureForDownloadableImage(this.mc.thePlayer.skinUrl, this.mc.thePlayer.addToPlayerScore()));
            GL11.glTranslated(-0.2f, -0.3f, 0.1f);
            GL11.glRotated(120.0f, 0.0f, 0.0f, 1.0f);
            GL11.glRotated(200.0f, 1.0f, 0.0f, 0.0f);
            GL11.glRotated(-135.0f, 0.0f, 1.0f, 0.0f);
            GL11.glScaled(0.0625f, 0.0625f, 0.0625f);
            GL11.glTranslated(6.0f, 0.0f, 0.0f);
            ((RenderPlayer)RenderManager.instance.getEntityRenderObject(this.mc.thePlayer)).drawFirstPersonHand();
            GL11.glPopMatrix();
        }
        GL11.glDisable(2977);
        RenderHelper.disableStandardItemLighting();
    }
    
    public final void renderOverlays(final double double1) {
        GL11.glDisable(3008);
        if (this.mc.thePlayer.fire > 0) {
            int i = this.mc.renderEngine.getTexture("/terrain.png");
            GL11.glBindTexture(3553, i);
            final Tessellator instance = Tessellator.instance;
            GL11.glColor4d(1.0f, 1.0f, 1.0f, 0.9f);
            GL11.glEnable(3042);
            GL11.glBlendFunc(770, 771);
            for (i = 0; i < 2; ++i) {
                GL11.glPushMatrix();
                int n2;
                final int n = ((n2 = Block.fire.blockIndexInTexture + (i << 4)) & 0xF) << 4;
                n2 &= 0xF0;
                final double n3 = n / 256.0f;
                final double n4 = (n + 15.99f) / 256.0f;
                final double n5 = n2 / 256.0f;
                final double n6 = (n2 + 15.99f) / 256.0f;
                GL11.glTranslated(-((i << 1) - 1) * 0.24f, -0.3f, 0.0f);
                GL11.glRotated(((i << 1) - 1) * 10.0f, 0.0f, 1.0f, 0.0f);
                instance.startDrawingQuads();
                instance.addVertexWithUV(-0.5f, -0.5f, -0.5f, n4, n6);
                instance.addVertexWithUV(0.5f, -0.5f, -0.5f, n3, n6);
                instance.addVertexWithUV(0.5f, 0.5f, -0.5f, n3, n5);
                instance.addVertexWithUV(-0.5f, 0.5f, -0.5f, n4, n5);
                instance.draw();
                GL11.glPopMatrix();
            }
            GL11.glColor4d(1.0f, 1.0f, 1.0f, 1.0f);
            GL11.glDisable(3042);
        }
        if (this.mc.thePlayer.isInsideOfMaterial()) {
            final int i = this.mc.renderEngine.getTexture("/water.png");
            GL11.glBindTexture(3553, i);
            double entityBrightness = double1;
            final Tessellator instance2 = Tessellator.instance;
            GL11.glColor4d(entityBrightness = this.mc.thePlayer.getEntityBrightness(entityBrightness), entityBrightness, entityBrightness, 0.5f);
            GL11.glEnable(3042);
            GL11.glBlendFunc(770, 771);
            GL11.glPushMatrix();
            final double n5 = -this.mc.thePlayer.rotationYaw / 64.0f;
            final double n6 = this.mc.thePlayer.rotationPitch / 64.0f;
            instance2.startDrawingQuads();
            instance2.addVertexWithUV(-1.0f, -1.0f, -0.5f, n5 + 4.0f, n6 + 4.0f);
            instance2.addVertexWithUV(1.0f, -1.0f, -0.5f, n5 + 0.0f, n6 + 4.0f);
            instance2.addVertexWithUV(1.0f, 1.0f, -0.5f, n5 + 0.0f, n6 + 0.0f);
            instance2.addVertexWithUV(-1.0f, 1.0f, -0.5f, n5 + 4.0f, n6 + 0.0f);
            instance2.draw();
            GL11.glPopMatrix();
            GL11.glColor4d(1.0f, 1.0f, 1.0f, 1.0f);
            GL11.glDisable(3042);
        }
        GL11.glEnable(3008);
    }
    
    public final void updateEquippedItem() {
        this.prevEquippedProgress = this.equippedProgress;
        if (this.itemSwingState) {
            ++this.equippedItemSlot;
            if (this.equippedItemSlot == 8) {
                this.equippedItemSlot = 0;
                this.itemSwingState = false;
            }
        }
        final ItemStack currentItem;
        double n;
        if ((n = (n = (((currentItem = this.mc.thePlayer.inventory.getCurrentItem()) == this.itemToRender) ? 1.0f : 0.0f)) - this.equippedProgress) < -0.4f) {
            n = -0.4f;
        }
        if (n > 0.4f) {
            n = 0.4f;
        }
        this.equippedProgress += n;
        if (this.equippedProgress < 0.1f) {
            this.itemToRender = currentItem;
        }
    }
    
    public final void equipAnimationSpeed() {
        this.equippedProgress = 0.0f;
    }
    
    public final void equippedItemRender() {
        this.equippedItemSlot = -1;
        this.itemSwingState = true;
    }
    
    public final void resetEquippedProgress() {
        this.equippedProgress = 0.0f;
    }
}
