package net.minecraft.client.renderer.block;

import net.minecraft.game.MathHelper;
import java.io.IOException;
import javax.imageio.ImageIO;
import net.minecraft.game.block.Block;

public class TextureGearsFX extends TextureFX {
    private int gearFrames2;
    private int[] gearColor;
    private int[] gearMiddleColor;
    private int gearFrames1;
    
    public TextureGearsFX(final int iconIndex) {
        super(Block.gear.blockIndexInTexture + iconIndex);
        this.gearFrames2 = 0;
        this.gearColor = new int[1024];
        this.gearMiddleColor = new int[1024];
        this.gearFrames1 = (iconIndex << 1) - 1;
        this.gearFrames2 = 2;
        try {
            ImageIO.read(TextureGearsFX.class.getResource("/misc/gear.png")).getRGB(0, 0, 32, 32, this.gearColor, 0, 32);
            ImageIO.read(TextureGearsFX.class.getResource("/misc/gearmiddle.png")).getRGB(0, 0, 16, 16, this.gearMiddleColor, 0, 16);
        }
        catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    
    @Override
    public final void onTick() {
        this.gearFrames2 = (this.gearFrames2 + this.gearFrames1 & 0x3F);
        final double sin = MathHelper.sin(this.gearFrames2 / 64.0f * 3.1415927f * 2.0f);
        final double cos = MathHelper.cos(this.gearFrames2 / 64.0f * 3.1415927f * 2.0f);
        for (int i = 0; i < 16; ++i) {
            for (int j = 0; j < 16; ++j) {
                double n = (i / 15.0f - 0.5f) * 31.0f;
                final double n2 = (j / 15.0f - 0.5f) * 31.0f;
                final double n3 = cos * n - sin * n2;
                n = cos * n2 + sin * n;
                int n4 = (int)(n3 + 16.0f);
                int n5 = (int)(n + 16.0f);
                int n6 = 0;
                if (n4 >= 0 && n5 >= 0 && n4 < 32 && n5 < 32) {
                    n6 = this.gearColor[n4 + (n5 << 5)];
                    if ((n5 = this.gearMiddleColor[i + (j << 4)]) >>> 24 > 128) {
                        n6 = n5;
                    }
                }
                n5 = (n6 >> 16 & 0xFF);
                n4 = (n6 >> 8 & 0xFF);
                final int n7 = n6 & 0xFF;
                n6 = ((n6 >>> 24 > 128) ? 255 : 0);
                final int n8 = i + (j << 4);
                this.imageData[n8 << 2] = (byte)n5;
                this.imageData[(n8 << 2) + 1] = (byte)n4;
                this.imageData[(n8 << 2) + 2] = (byte)n7;
                this.imageData[(n8 << 2) + 3] = (byte)n6;
            }
        }
    }
}
