package net.minecraft.client.renderer.block;

import net.minecraft.game.MathHelper;
import net.minecraft.game.block.Block;

public final class TextureLavaFX extends TextureFX {
    private double[] red;
    private double[] green;
    private double[] blue;
    private double[] alpha;
    
    public TextureLavaFX() {
        super(Block.lavaMoving.blockIndexInTexture);
        this.red = new double[256];
        this.green = new double[256];
        this.blue = new double[256];
        this.alpha = new double[256];
    }
    
    @Override
    public final void onTick() {
        for (int i = 0; i < 16; ++i) {
            for (int j = 0; j < 16; ++j) {
                double n = 0.0f;
                final int n2 = (int)(MathHelper.sin(j * 3.1415927f * 2.0f / 16.0f) * 1.2f);
                final int n3 = (int)(MathHelper.sin(i * 3.1415927f * 2.0f / 16.0f) * 1.2f);
                for (int k = i - 1; k <= i + 1; ++k) {
                    for (int l = j - 1; l <= j + 1; ++l) {
                        final int n4 = k + n2 & 0xF;
                        final int n5 = l + n3 & 0xF;
                        n += this.red[n4 + (n5 << 4)];
                    }
                }
                this.green[i + (j << 4)] = n / 10.0f + (this.blue[(i & 0xF) + ((j & 0xF) << 4)] + this.blue[(i + 1 & 0xF) + ((j & 0xF) << 4)] + this.blue[(i + 1 & 0xF) + ((j + 1 & 0xF) << 4)] + this.blue[(i & 0xF) + ((j + 1 & 0xF) << 4)]) / 4.0f * 0.8f;
                final double[] blue = this.blue;
                final int n6 = i + (j << 4);
                blue[n6] += this.alpha[i + (j << 4)] * 0.01f;
                if (this.blue[i + (j << 4)] < 0.0f) {
                    this.blue[i + (j << 4)] = 0.0f;
                }
                final double[] alpha = this.alpha;
                final int n7 = i + (j << 4);
                alpha[n7] -= 0.06f;
                if (Math.random() < 0.005) {
                    this.alpha[i + (j << 4)] = 1.5f;
                }
            }
        }
        final double[] green = this.green;
        this.green = this.red;
        this.red = green;
        for (int j = 0; j < 256; ++j) {
            double n;
            if ((n = this.red[j] * 2.0f) > 1.0f) {
                n = 1.0f;
            }
            if (n < 0.0f) {
                n = 0.0f;
            }
            final double n8;
            int n3 = (int)((n8 = n) * 100.0f + 155.0f);
            int k = (int)(n8 * n8 * 255.0f);
            int l = (int)(n8 * n8 * n8 * n8 * 128.0f);
            if (this.anaglyphEnabled) {
                final int n4 = (n3 * 30 + k * 59 + l * 11) / 100;
                final int n5 = (n3 * 30 + k * 70) / 100;
                final int i = (n3 * 30 + l * 70) / 100;
                n3 = n4;
                k = n5;
                l = i;
            }
            this.imageData[j << 2] = (byte)n3;
            this.imageData[(j << 2) + 1] = (byte)k;
            this.imageData[(j << 2) + 2] = (byte)l;
            this.imageData[(j << 2) + 3] = -1;
        }
    }
}
