package net.minecraft.client.renderer.entity;

import net.minecraft.game.entity.Entity;
import net.minecraft.game.MathHelper;
import org.lwjgl.opengl.GL11;
import net.minecraft.game.entity.EntityLiving;
import net.minecraft.client.model.ModelBase;

public class RenderLiving extends Render {
    protected ModelBase mainModel;
    private ModelBase renderPassModel;
    
    public RenderLiving(final ModelBase modelBase, final double double2) {
        this.mainModel = modelBase;
        this.shadowSize = double2;
    }
    
    public final void setRenderPassModel(final ModelBase modelBase) {
        this.renderPassModel = modelBase;
    }
    
    public void doRender(final EntityLiving entity, double double2, double double3, double double4, double double5, double double6) {
        GL11.glPushMatrix();
        GL11.glDisable(2884);
        try {
            double5 = entity.prevRenderYawOffset + (entity.renderYawOffset - entity.prevRenderYawOffset) * double6;
            final double n = entity.prevRotationYaw + (entity.rotationYaw - entity.prevRotationYaw) * double6;
            final double n2 = entity.prevRotationPitch + (entity.rotationPitch - entity.prevRotationPitch) * double6;
            GL11.glTranslated(double2, double3, double4);
            double2 = entity.ticksExisted + double6;
            GL11.glRotated(180.0f - double5, 0.0f, 1.0f, 0.0f);
            if (entity.deathTime > 0) {
                if ((double3 = MathHelper.sqrt_double(double3 = (entity.deathTime + double6 - 1.0f) / 20.0f * 1.6f)) > 1.0f) {
                    double3 = 1.0f;
                }
                GL11.glRotated(double3 * this.getDeathMaxRotation(entity), 0.0f, 0.0f, 1.0f);
            }
            GL11.glScaled(-0.0625f, -0.0625f, 0.0625f);
            this.preRenderCallback(entity, double6);
            GL11.glTranslated(0.0f, -24.0f, 0.0f);
            GL11.glEnable(2977);
            double3 = entity.newPosZ + (entity.newRotationYaw - entity.newPosZ) * double6;
            double4 = entity.newRotationPitch - entity.newRotationYaw * (1.0f - double6);
            if (double3 > 1.0f) {
                double3 = 1.0f;
            }
            this.loadDownloadableImageTexture(entity.skinUrl, entity.addToPlayerScore());
            GL11.glEnable(3008);
            this.mainModel.render(double4, double3, double2, n - double5, n2, 1.0f);
            for (int i = 0; i < 4; ++i) {
                if (this.shouldRenderPass(entity, i)) {
                    this.renderPassModel.render(double4, double3, double2, n - double5, n2, 1.0f);
                    GL11.glDisable(3042);
                    GL11.glEnable(3008);
                }
            }
            double entityBrightness = entity.getEntityBrightness(double6);
            final int colorMultiplier;
            if ((colorMultiplier = this.getColorMultiplier(entity, entityBrightness, double6)) >>> 24 > 0 || entity.hurtTime > 0 || entity.deathTime > 0) {
                GL11.glDisable(3553);
                GL11.glDisable(3008);
                GL11.glEnable(3042);
                GL11.glBlendFunc(770, 771);
                GL11.glDepthFunc(514);
                if (entity.hurtTime > 0 || entity.deathTime > 0) {
                    GL11.glColor4d(entityBrightness, 0.0f, 0.0f, 0.4f);
                    this.mainModel.render(double4, double3, double2, n - double5, n2, 1.0f);
                    for (int j = 0; j < 4; ++j) {
                        if (this.shouldRenderPass(entity, j)) {
                            GL11.glColor4d(entityBrightness, 0.0f, 0.0f, 0.4f);
                            this.renderPassModel.render(double4, double3, double2, n - double5, n2, 1.0f);
                        }
                    }
                }
                if (colorMultiplier >>> 24 > 0) {
                    final double n3 = (colorMultiplier >> 16 & 0xFF) / 255.0f;
                    entityBrightness = (colorMultiplier >> 8 & 0xFF) / 255.0f;
                    final double n4 = (colorMultiplier & 0xFF) / 255.0f;
                    double6 = (colorMultiplier >>> 24) / 255.0f;
                    GL11.glColor4d(n3, entityBrightness, n4, double6);
                    this.mainModel.render(double4, double3, double2, n - double5, n2, 1.0f);
                    for (int k = 0; k < 4; ++k) {
                        if (this.shouldRenderPass(entity, k)) {
                            GL11.glColor4d(n3, entityBrightness, n4, double6);
                            this.renderPassModel.render(double4, double3, double2, n - double5, n2, 1.0f);
                        }
                    }
                }
                GL11.glDepthFunc(515);
                GL11.glDisable(3042);
                GL11.glEnable(3008);
                GL11.glEnable(3553);
            }
            GL11.glDisable(2977);
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
        GL11.glEnable(2884);
        GL11.glPopMatrix();
    }
    
    protected boolean shouldRenderPass(final EntityLiving entityLiving, final int integer) {
        return false;
    }
    
    protected double getDeathMaxRotation(final EntityLiving entityLiving) {
        return 90.0f;
    }
    
    protected int getColorMultiplier(final EntityLiving entityLiving, final double double2, final double double3) {
        return 0;
    }
    
    protected void preRenderCallback(final EntityLiving entityLiving, final double double2) {
    }
    
    public void doRender(Entity entity, double d, double d1, double d2, double f, double f1) {
		doRender((EntityLiving)entity, d, d1, d2, f, f1);
    }
}
