package net.minecraft.client.renderer.entity;

import net.minecraft.game.entity.other.EnumArt;
import net.minecraft.client.renderer.Tessellator;
import org.lwjgl.opengl.GL11;
import net.minecraft.game.entity.other.EntityPainting;
import net.minecraft.game.entity.Entity;
import java.util.Random;

public final class RenderPainting extends Render {
    private Random rand;
    
    public RenderPainting() {
        this.rand = new Random();
    }
    
    public final void doRender(Entity entity, double f, double f2, double f3, double f4, double f5) {
        EntityPainting painting = (EntityPainting) entity;
        this.rand.setSeed(187);
        GL11.glPushMatrix();
        GL11.glTranslated(f, f2, f3);
        GL11.glRotated(f4, 0.0f, 1.0f, 0.0f);
        GL11.glEnable(2977);
        loadTexture("/art/kz.png");
        EnumArt paintingType = painting.art;
        GL11.glScaled(0.0625f, 0.0625f, 0.0625f);
        int i = paintingType.sizeX;
        int i2 = paintingType.sizeY;
        int i3 = paintingType.offsetX;
        int i4 = paintingType.offsetY;
        double f6 = ((double) (-i)) / 2.0f;
        double f7 = ((double) (-i2)) / 2.0f;
        for (int i5 = 0; i5 < i / 16; i5++) {
            for (int i6 = 0; i6 < i2 / 16; i6++) {
                double f8 = f6 + ((double) ((i5 + 1) << 4));
                double f9 = f6 + ((double) (i5 << 4));
                double f10 = f7 + ((double) ((i6 + 1) << 4));
                double f11 = f7 + ((double) (i6 << 4));
                double f12 = (f8 + f9) / 2.0f;
                int i7 = (int) painting.posX;
                int i8 = (int) ((((f10 + f11) / 2.0f) / 16.0f) + painting.posY);
                int i9 = (int) painting.posZ;
                if (painting.direction == 0) {
                    i7 = (int) (painting.posX + (f12 / 16.0f));
                }
                if (painting.direction == 1) {
                    i9 = (int) (painting.posZ - (f12 / 16.0f));
                }
                if (painting.direction == 2) {
                    i7 = (int) (painting.posX - (f12 / 16.0f));
                }
                if (painting.direction == 3) {
                    i9 = (int) (painting.posZ + (f12 / 16.0f));
                }
                double c = this.renderManager.worldObj.getLightBrightness(i7, i8, i9);
                GL11.glColor3d(c, c, c);
                double f13 = ((double) ((i3 + i) - (i5 << 4))) / 256.0f;
                double f14 = ((double) ((i3 + i) - ((i5 + 1) << 4))) / 256.0f;
                double f15 = ((double) ((i4 + i2) - (i6 << 4))) / 256.0f;
                double f16 = ((double) ((i4 + i2) - ((i6 + 1) << 4))) / 256.0f;
                Tessellator dVar2 = Tessellator.instance;
                dVar2.startDrawingQuads();
                Tessellator.setNormal(0.0f, 0.0f, -1.0f);
                dVar2.addVertexWithUV(f8, f11, -0.5f, f14, f15);
                dVar2.addVertexWithUV(f9, f11, -0.5f, f13, f15);
                dVar2.addVertexWithUV(f9, f10, -0.5f, f13, f16);
                dVar2.addVertexWithUV(f8, f10, -0.5f, f14, f16);
                Tessellator.setNormal(0.0f, 0.0f, 1.0f);
                dVar2.addVertexWithUV(f8, f10, 0.5f, 0.75f, 0.0f);
                dVar2.addVertexWithUV(f9, f10, 0.5f, 0.8125f, 0.0f);
                dVar2.addVertexWithUV(f9, f11, 0.5f, 0.8125f, 0.0625f);
                dVar2.addVertexWithUV(f8, f11, 0.5f, 0.75f, 0.0625f);
                Tessellator.setNormal(0.0f, -1.0f, 0.0f);
                dVar2.addVertexWithUV(f8, f10, -0.5f, 0.75f, 0.001953125f);
                dVar2.addVertexWithUV(f9, f10, -0.5f, 0.8125f, 0.001953125f);
                dVar2.addVertexWithUV(f9, f10, 0.5f, 0.8125f, 0.001953125f);
                dVar2.addVertexWithUV(f8, f10, 0.5f, 0.75f, 0.001953125f);
                Tessellator.setNormal(0.0f, 1.0f, 0.0f);
                dVar2.addVertexWithUV(f8, f11, 0.5f, 0.75f, 0.001953125f);
                dVar2.addVertexWithUV(f9, f11, 0.5f, 0.8125f, 0.001953125f);
                dVar2.addVertexWithUV(f9, f11, -0.5f, 0.8125f, 0.001953125f);
                dVar2.addVertexWithUV(f8, f11, -0.5f, 0.75f, 0.001953125f);
                Tessellator.setNormal(-1.0f, 0.0f, 0.0f);
                dVar2.addVertexWithUV(f8, f10, 0.5f, 0.7519531f, 0.0f);
                dVar2.addVertexWithUV(f8, f11, 0.5f, 0.7519531f, 0.0625f);
                dVar2.addVertexWithUV(f8, f11, -0.5f, 0.7519531f, 0.0625f);
                dVar2.addVertexWithUV(f8, f10, -0.5f, 0.7519531f, 0.0f);
                Tessellator.setNormal(1.0f, 0.0f, 0.0f);
                dVar2.addVertexWithUV(f9, f10, -0.5f, 0.7519531f, 0.0f);
                dVar2.addVertexWithUV(f9, f11, -0.5f, 0.7519531f, 0.0625f);
                dVar2.addVertexWithUV(f9, f11, 0.5f, 0.7519531f, 0.0625f);
                dVar2.addVertexWithUV(f9, f10, 0.5f, 0.7519531f, 0.0f);
                dVar2.draw();
            }
        }
        GL11.glDisable(2977);
        GL11.glPopMatrix();
    }

}
