package net.minecraft.game.block;

import net.minecraft.game.block.tileentity.TileEntity;
import net.minecraft.game.level.World;

public abstract class BlockContainer extends Block {
    protected BlockContainer(final int blockID, final Material material) {
        super(blockID, material);
    }
    
    @Override
    public void onBlockAdded(final World world, final int xCoord, final int yCoord, final int zCoord) {
        super.onBlockAdded(world, xCoord, yCoord, zCoord);
        world.setBlockTileEntity(xCoord, yCoord, zCoord, this.getBlockEntity());
    }
    
    @Override
    public void onBlockRemoval(final World world, final int xCoord, final int yCoord, final int zCoord) {
        super.onBlockRemoval(world, xCoord, yCoord, zCoord);
        world.removeBlockTileEntity(xCoord, yCoord, zCoord);
    }
    
    protected abstract TileEntity getBlockEntity();
}
