package net.minecraft.game.block;

import java.util.Random;
import net.minecraft.game.level.World;

public final class BlockLeaves extends BlockLeavesBase {
    protected BlockLeaves(final int blockID, final int textureSlot) {
        super(18, 52, Material.leaves, true);
        this.setTickOnLoad(true);
    }
    
    @Override
    public final void updateTick(final World world, final int xCoord, final int yCoord, final int zCoord, final Random random) {
        if (world.getBlockMaterial(xCoord, yCoord - 1, zCoord).isSolid()) {
            return;
        }
        for (int i = xCoord - 2; i <= xCoord + 2; ++i) {
            for (int j = yCoord - 1; j <= yCoord; ++j) {
                for (int k = zCoord - 2; k <= zCoord + 2; ++k) {
                    if (world.getBlockId(i, j, k) == Block.wood.blockID) {
                        return;
                    }
                }
            }
        }
        this.dropBlockAsItem(world, xCoord, yCoord, zCoord, world.getBlockMetadata(xCoord, yCoord, zCoord));
        world.setBlockWithNotify(xCoord, yCoord, zCoord, 0);
    }
    
    @Override
    public final int quantityDropped(final Random random) {
        if (random.nextInt(10) == 0) {
            return 1;
        }
        return 0;
    }
    
    @Override
    public final int idDropped(final int integer, final Random random) {
        return Block.sapling.blockID;
    }
}
