package net.minecraft.game.block;

import net.minecraft.game.level.World;

public final class BlockMushroom extends BlockFlower {
    protected BlockMushroom(final int blockID, final int textureSlot) {
        super(blockID, textureSlot);
        this.setBlockBounds(0.3f, 0.0f, 0.3f, 0.7f, 0.4f, 0.7f);
    }
    
    @Override
    protected final boolean canThisPlantGrowOnThisBlockID(final int blockID) {
        return Block.opaqueCubeLookup[blockID];
    }
    
    @Override
    public final boolean canBlockStay(final World world, int xCoord, final int yCoord, final int zCoord) {
        if (world.getBlockLightValue(xCoord, yCoord, zCoord) <= 13) {
            xCoord = world.getBlockId(xCoord, yCoord - 1, zCoord);
            if (Block.opaqueCubeLookup[xCoord]) {
                return true;
            }
        }
        return false;
    }
}
