package net.minecraft.game.block;

import net.minecraft.game.level.World;
import java.util.Random;

public class BlockSand extends Block {
    public BlockSand(final int blockID, final int textureSlot) {
        super(blockID, textureSlot, Material.sand);
        new Random();
    }
    
    @Override
    public final void onBlockAdded(final World world, final int xCoord, final int yCoord, final int zCoord) {
        this.scheduleBlockUpdate(world, xCoord, yCoord, zCoord);
    }
    
    @Override
    public final void onNeighborBlockChange(final World world, final int xCoord, final int yCoord, final int zCoord, final int blockID) {
        this.scheduleBlockUpdate(world, xCoord, yCoord, zCoord);
    }
    
    private void scheduleBlockUpdate(final World world, final int integer2, final int integer3, final int integer4) {
        int integer5 = integer3;
        int n;
        Material blockMaterial;
        while (((n = world.getBlockId(integer2, integer5 - 1, integer4)) == 0 || n == Block.fire.blockID || (blockMaterial = Block.blocksList[n].blockMaterial) == Material.water || blockMaterial == Material.lava) && integer5 >= 0) {
            --integer5;
            if (world.getBlockId(integer2, integer5, integer4) == Block.fire.blockID) {
                world.setTileNoNeighborChange(integer2, integer5, integer4, 0);
            }
        }
        if (integer5 < 0) {
            world.setTileNoUpdate(integer2, integer3, integer4, 0);
        }
        if (integer5 != integer3) {
            if ((n = world.getBlockId(integer2, integer5, integer4)) > 0 && Block.blocksList[n].blockMaterial != Material.air) {
                world.setTileNoUpdate(integer2, integer5, integer4, 0);
            }
            world.swap(integer2, integer3, integer4, integer2, integer5, integer4);
        }
    }
}
