package net.minecraft.game.entity.animal;

import com.nbt.NBTTagCompound;
import net.minecraft.game.entity.other.EntityItem;
import net.minecraft.game.block.Block;
import net.minecraft.game.entity.EntityLiving;
import net.minecraft.game.entity.Entity;
import net.minecraft.game.level.World;

public class EntitySheep extends EntityAnimals {
    public boolean sheared;
    
    public EntitySheep(final World world) {
        super(world);
        this.sheared = false;
        this.texture = "/mob/sheep.png";
        this.setSize(0.9f, 1.3f);
    }
    
    @Override
    public final boolean attackEntityFrom(final Entity entity, final int integer) {
        if (!this.sheared && entity instanceof EntityLiving) {
            this.sheared = true;
            for (int n = 1 + this.rand.nextInt(3), i = 0; i < n; ++i) {
                final EntityItem entityDropItem;
                final EntityItem entityItem = entityDropItem = this.entityDropItem(Block.woolGray.blockID, 1, 1.0f);
                entityItem.motionY += this.rand.nextDouble() * 0.05f;
                final EntityItem entityItem2 = entityDropItem;
                entityItem2.motionX += (this.rand.nextDouble() - this.rand.nextDouble()) * 0.1f;
                final EntityItem entityItem3 = entityDropItem;
                entityItem3.motionZ += (this.rand.nextDouble() - this.rand.nextDouble()) * 0.1f;
            }
        }
        return super.attackEntityFrom(entity, integer);
    }
    
    @Override
    protected final void writeEntityToNBT(final NBTTagCompound nbtTagCompound) {
        super.writeEntityToNBT(nbtTagCompound);
        nbtTagCompound.setBoolean("Sheared", this.sheared);
    }
    
    @Override
    protected final void readEntityFromNBT(final NBTTagCompound nbtTagCompound) {
        super.readEntityFromNBT(nbtTagCompound);
        this.sheared = nbtTagCompound.getBoolean("Sheared");
    }
    
    @Override
    protected final String getEntityString() {
        return "Sheep";
    }
    
    @Override
    protected final String getLivingSound() {
        return "mob.sheep";
    }
    
    @Override
    protected final String getHurtSound() {
        return "mob.sheep";
    }
    
    @Override
    protected final String getDeathSound() {
        return "mob.sheep";
    }
}
