package net.minecraft.game.entity.monster;

import net.minecraft.game.item.Item;
import net.minecraft.game.level.World;

public class EntityZombie extends EntityMonster {
    public EntityZombie(final World world) {
        super(world);
        this.texture = "/mob/zombie.png";
        this.moveSpeed = 0.5f;
        this.attackStrength = 5;
    }
    
    @Override
    public final void onLivingUpdate() {
        final double entityBrightness;
        if (this.worldObj.skylightSubtracted > 7 && (entityBrightness = this.getEntityBrightness(1.0f)) > 0.5f && this.worldObj.canBlockSeeTheSky((int)this.posX, (int)this.posY, (int)this.posZ) && this.rand.nextDouble() * 30.0f < (entityBrightness - 0.4f) * 2.0f) {
            this.fire = 300;
        }
        super.onLivingUpdate();
    }
    
    @Override
    protected final String getEntityString() {
        return "Zombie";
    }
    
    @Override
    protected final int scoreValue() {
        return Item.feather.shiftedIndex;
    }
}
