package net.minecraft.game.item;

public final class ItemArmor extends Item {
    private static final int[] damageReduceAmountArray;
    private static final int[] maxDamageArray;
    public final int armorType;
    public final int damageReduceAmount;
    public final int renderIndex;
    
    public ItemArmor(final int itemID, final int armorLevel, final int armorTexture, final int armorType) {
        super(itemID);
        this.armorType = armorType;
        this.renderIndex = armorTexture;
        this.damageReduceAmount = ItemArmor.damageReduceAmountArray[armorType];
        this.maxDamage = ItemArmor.maxDamageArray[armorType] * 3 << armorLevel;
        this.maxStackSize = 1;
    }
    
    static {
        damageReduceAmountArray = new int[] { 3, 8, 6, 3 };
        maxDamageArray = new int[] { 11, 16, 15, 13 };
    }
}
