package net.minecraft.game.item;

import net.minecraft.game.level.World;
import net.minecraft.game.block.Block;

public final class ItemBlock extends Item {
    private int blockID;
    
    public ItemBlock(final int itemID) {
        super(itemID);
        this.blockID = itemID + 256;
        this.setIconIndex(Block.blocksList[itemID + 256].getBlockTextureFromSide(2));
    }
    
    @Override
    public final boolean onItemUse(final ItemStack itemStack, final World world, int integer3, int integer4, int integer5, final int integer6) {
        if (integer6 == 0) {
            --integer4;
        }
        if (integer6 == 1) {
            ++integer4;
        }
        if (integer6 == 2) {
            --integer5;
        }
        if (integer6 == 3) {
            ++integer5;
        }
        if (integer6 == 4) {
            --integer3;
        }
        if (integer6 == 5) {
            ++integer3;
        }
        if (itemStack.stackSize == 0) {
            return false;
        }
        final Block block = Block.blocksList[world.getBlockId(integer3, integer4, integer5)];
        final Block block2;
        if (((this.blockID > 0 && block == null) || block == Block.waterMoving || block == Block.waterStill || block == Block.lavaMoving || block == Block.lavaStill || block == Block.fire) && world.checkIfAABBIsClear((block2 = Block.blocksList[this.blockID]).getCollisionBoundingBoxFromPool(integer3, integer4, integer5)) && block2.canPlaceBlockAt(world, integer3, integer4, integer5) && world.setBlockWithNotify(integer3, integer4, integer5, this.blockID)) {
            Block.blocksList[this.blockID].onBlockPlaced(world, integer3, integer4, integer5, integer6);
            world.playSoundAtPlayer(integer3 + 0.5f, integer4 + 0.5f, integer5 + 0.5f, block2.stepSound.stepSoundDir2(), (block2.stepSound.soundVolume + 1.0f) / 2.0f, block2.stepSound.soundPitch * 0.8f);
            if(world.survivalWorld)
            	--itemStack.stackSize;
        }
        return true;
    }
}
