package net.minecraft.game.item;

import com.nbt.NBTTagCompound;
import net.minecraft.game.block.Block;

public final class ItemStack {
    public int stackSize;
    public int animationsToGo;
    public int itemID;
    public int itemDamage;
    
    public ItemStack(final Block block) {
        this(block, 1);
    }
    
    public ItemStack(final Block block, final int integer) {
        this(block.blockID, integer);
    }
    
    public ItemStack(final Item item) {
        this(item, 1);
    }
    
    public ItemStack(final Item item, final int integer) {
        this(item.shiftedIndex, integer);
    }
    
    public ItemStack(final int integer) {
        this(integer, 1);
    }
    
    public ItemStack(final int integer1, final int integer2) {
        this.stackSize = 0;
        this.itemID = integer1;
        this.stackSize = integer2;
    }
    
    public ItemStack(final int integer1, final int integer2, final int integer3) {
        this.stackSize = 0;
        this.itemID = integer1;
        this.stackSize = integer2;
        this.itemDamage = integer3;
    }
    
    public ItemStack(final NBTTagCompound nbtTagCompound) {
        this.stackSize = 0;
        this.itemID = nbtTagCompound.getShort("id");
        this.stackSize = nbtTagCompound.getByte("Count");
        this.itemDamage = nbtTagCompound.getShort("Damage");
    }
    
    public final ItemStack splitStack(final int integer) {
        this.stackSize -= integer;
        return new ItemStack(this.itemID, integer, this.itemDamage);
    }
    
    public final Item getItem() {
        return Item.itemsList[this.itemID];
    }
    
    public final NBTTagCompound writeToNBT(final NBTTagCompound nbtTagCompound) {
        nbtTagCompound.setShort("id", (short)this.itemID);
        nbtTagCompound.setByte("Count", (byte)this.stackSize);
        nbtTagCompound.setShort("Damage", (short)this.itemDamage);
        return nbtTagCompound;
    }
    
    public final int isItemStackDamageable() {
        return Item.itemsList[this.itemID].getMaxDamage();
    }
    
    public final void damageItem(final int integer) {
        this.itemDamage += integer;
        if (this.itemDamage > this.isItemStackDamageable()) {
            --this.stackSize;
            if (this.stackSize < 0) {
                this.stackSize = 0;
            }
            this.itemDamage = 0;
        }
    }
}
