package net.minecraft.game.level;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import net.minecraft.game.entity.Entity;
import net.minecraft.client.Minecraft;
import net.minecraft.client.physics.AxisAlignedBB;
import net.minecraft.client.renderer.Frustrum;
import net.minecraft.client.renderer.RenderEngine;
import net.minecraft.client.renderer.Vec3D;
import net.minecraft.client.renderer.entity.RenderManager;

public class BlockMap implements Serializable {

	private World world;
	private Minecraft mc;

	public BlockMap(World world) {
		this.world = world;
		this.mc = Minecraft.getInstance();
	}
	
	private static final long serialVersionUID = -191029894052812286L;
	public List<Entity> all = new ArrayList<>();

	public List<Entity> getEntities(Entity entity, AxisAlignedBB aabb) {
		List<Entity> entities = new ArrayList<>();
		if(aabb==null)
			return entities;
		for (Entity e : all)
			if (e != entity && e.boundingBox.intersectsWith(aabb)) {
				entities.add(e);
			}
		return entities;
	}

	public List getEntities(Entity entity, double x0, double y0, double z0, double x1, double y1, double z1) {
		// TODO Auto-generated method stub
		return getEntities(entity, new AxisAlignedBB(x0, y0, z0, x1, y1, z1));
	}

	public void insert(Entity var1) {
		if (var1 == null)
			return;
		all.add(var1);
	}

	public void moved(Entity var1) {
		// TODO Auto-generated method stub

	}

	public void remove(Entity var1) {
		all.remove(var1);
	}

	public void tickAll() {
		for (int i = 0; i < all.size(); i++) {
			all.get(i).onEntityUpdate();
			if (all.get(i).isDead)
				all.remove(i--);
		}
	}

	public void render(Vec3D var1, Frustrum var2, RenderEngine var3, double var4) {
		for (Entity var22 : all) {
			int var5 = (int) var22.posX;
			int var8 = (int) var22.posY;
			int var11 = (int) var22.posZ;
			if (var2.isBoundingBoxInFrustrum(var22.boundingBox)) {
				Frustrum var19 = var2;
				int var20 = 0;
				if(var22==world.player&&!mc.gameSettings.thirdPersonView)
					continue;
				RenderManager.instance.renderEntity(var22, 1);
			}
		}
	}

	public List getEntitiesWithinAABBExcludingEntity(Entity entity, AxisAlignedBB aabb) {
		return this.getEntities(entity, aabb);
	}

}
