package net.minecraft.game.recipe;

import net.minecraft.game.item.ItemStack;

public final class ShapelessRecipes {
    private int width;
    private int height;
    private int[] ingredientMap;
    private ItemStack recipeOutput;
    
    public ShapelessRecipes(final int width, final int height, final int[] ingredientMap, final ItemStack recipeOutput) {
        this.width = width;
        this.height = height;
        this.ingredientMap = ingredientMap;
        this.recipeOutput = recipeOutput;
    }
    
    public final boolean matchRecipe(final int[] arr) {
        for (int i = 0; i <= 3 - this.width; ++i) {
            for (int j = 0; j <= 3 - this.height; ++j) {
                if (this.matches(arr, i, j, true)) {
                    return true;
                }
                if (this.matches(arr, i, j, false)) {
                    return true;
                }
            }
        }
        return false;
    }
    
    private boolean matches(final int[] arr, final int integer2, final int integer3, final boolean boolean4) {
        for (int i = 0; i < 3; ++i) {
            for (int j = 0; j < 3; ++j) {
                final int n = i - integer2;
                final int n2 = j - integer3;
                int n3 = -1;
                if (n >= 0 && n2 >= 0 && n < this.width && n2 < this.height) {
                    if (boolean4) {
                        n3 = this.ingredientMap[this.width - n - 1 + n2 * this.width];
                    }
                    else {
                        n3 = this.ingredientMap[n + n2 * this.width];
                    }
                }
                if (arr[i + j * 3] != n3) {
                    return false;
                }
            }
        }
        return true;
    }
    
    public final ItemStack createResult() {
        return new ItemStack(this.recipeOutput.itemID, this.recipeOutput.stackSize);
    }
    
    public final int getRecipeSize() {
        return this.width * this.height;
    }
}
